
#include "stm32f10x_lib.h"



//************************************************************************************************
//*** asSerialInit
//***
//***
//************************************************************************************************
int asSerialInit()
{
  USART_InitTypeDef sUart;
  GPIO_InitTypeDef sPit;
  GPIO_StructInit(&sPit);

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1 | RCC_APB2Periph_GPIOA |RCC_APB2Periph_GPIOA
                         | RCC_APB2Periph_AFIO, ENABLE);

  // USART1 Tx (PA.09)
  sPit.GPIO_Pin = GPIO_Pin_9;
  sPit.GPIO_Speed = GPIO_Speed_50MHz;
  sPit.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOA, &sPit);

  // USART1 Rx (PA.10)
  sPit.GPIO_Pin = GPIO_Pin_10;
  sPit.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_Init(GPIOA, &sPit);
  
  // USART1 parameter
  USART_StructInit(&sUart);
  sUart.USART_BaudRate=             19200;
  sUart.USART_WordLength=           USART_WordLength_8b;
  sUart.USART_StopBits=             USART_StopBits_1;
  sUart.USART_Parity=               USART_Parity_No;
  sUart.USART_HardwareFlowControl=  USART_HardwareFlowControl_None;
  sUart.USART_Mode=                 USART_Mode_Tx | USART_Mode_Rx;
/* not here...
  sUart.USART_Clock=                USART_Clock_Disable;
  sUart.USART_CPOL=                 USART_CPOL_High;
  sUart.USART_CPHA=                 USART_CPHA_1Edge;
  sUart.USART_LastBit=              USART_LastBit_Enable;
*/
  USART_Init(USART1,&sUart);
  USART_Cmd(USART1, ENABLE);
  
}




//************************************************************************************************
//*** asSerialSendString
//***
//***
//************************************************************************************************
int asSerialSendString(char *data)
{
  char *pdat=data;

  while(*pdat != 0)
  {
    USART_SendData(USART1,(*pdat++)&0x7f);
    while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET)
    {;}
  }
}


//************************************************************************************************
//*** asRecvString
//***
//***
//************************************************************************************************
int asSerialReceiveString(char *data, int maxlen)
{
  char *pdat=data;
  int len=0;

  while(maxlen--)
  {
    // WARNING: this could block!
    while(USART_GetFlagStatus(USART1,USART_FLAG_RXNE)==RESET)
    {;}
    *pdat=USART_ReceiveData(USART1) & 0x7F;  
    len++;
    USART_ClearFlag(USART1,USART_FLAG_RXNE);
    
    if(*pdat=='\r')
    {
      *(pdat+1)='\n';
      *(pdat+2)=0;
      return len+1;
    }

    USART_SendData(USART1,(*pdat)&0x7f);
    while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET)
    {;}
    pdat++;
  }
  *data=0;
  return -1;
}


